create table departments (department_acronym char(3) not null, creation_instant timestamp not null, modification_instant timestamp not null, name varchar(255) not null, faculty_acronym char(3) not null, primary key (department_acronym));
create table faculties (faculty_acronym char(3) not null, creation_instant timestamp not null, modification_instant timestamp not null, name varchar(255) not null, primary key (faculty_acronym));
create table project_documents (project_document_id uuid not null, content bytea not null, creation_instant timestamp not null, modification_instant timestamp not null, title varchar(255) not null, project_id uuid not null, primary key (project_document_id)) partition by range (creation_instant);
create table project_documents_2023 partition of projects for values from ('2023-01-01') to ('2024-01-01');
create table projects (project_id uuid not null, creation_instant timestamp not null, deadline date not null, grade numeric(2, 1), modification_instant timestamp not null, status char(3) not null, student_signature bytea, supervising_tutor_1_accepted boolean not null, supervising_tutor_1_signature bytea, supervising_tutor_2_accepted boolean not null, supervising_tutor_2_signature bytea, title varchar(255) not null, department_acronym char(3) not null, faculty_acronym char(3) not null, student_id uuid not null, supervising_tutor_1_id uuid not null, supervising_tutor_2_id uuid, primary key (project_id)) partition by range (creation_instant);
create table projects_2023 partition of projects for values from ('2023-01-01') to ('2024-01-01');
create table user_departments (department_acronym char(3) not null, user_id uuid not null);
create table user_faculties (user_id uuid not null, faculty_acronym char(3) not null);
create table users (user_id uuid not null, admin boolean not null, creation_instant timestamp not null, email varchar(254) not null, examination_authority boolean not null, faculty_board_of_examiners boolean not null, modification_instant timestamp not null, password varchar(60) not null, user_type char(3) not null, primary key (user_id));
alter table if exists project_documents add constraint uk_project_documents unique (title);
alter table if exists users add constraint uk_users_email unique (email);
alter table if exists departments add constraint fk_departments_f_acronym foreign key (faculty_acronym) references faculties;
alter table if exists project_documents add constraint fk_projects_document_p_id foreign key (project_id) references projects;
alter table if exists projects add constraint fk_projects_d_acronym foreign key (department_acronym) references departments;
alter table if exists projects add constraint fk_projects_f_acronym foreign key (faculty_acronym) references faculties;
alter table if exists projects add constraint fk_projects_student_id foreign key (student_id) references users;
alter table if exists projects add constraint fk_projects_tutor_1_id foreign key (supervising_tutor_1_id) references users;
alter table if exists projects add constraint fk_projects_tutor_2_id foreign key (supervising_tutor_2_id) references users;
alter table if exists user_departments add constraint fk_user_departments_u_id foreign key (user_id) references users;
alter table if exists user_departments add constraint fk_user_departments_d_acr foreign key (department_acronym) references departments;
alter table if exists user_faculties add constraint fk_user_faculties_f_acr foreign key (faculty_acronym) references faculties;
alter table if exists user_faculties add constraint fk_user_faculties_u_id foreign key (user_id) references users;
